#macro Term( L )
   #local h1 = L/10;
   #local h2 = 2*h1;
   #local s1 = L/1000;
   #local s2 = 2*s1;
   #local try1 = 2*L/100;
   #local trx2 = 0.6*L;
   #local try2 = 0.45*L;
   #union{
      cylinder{<0,0,0>, <0,h1,0>, s1 translate <0,try1,L>              }
      cylinder{<0,0,0>, <0,h1,0>, s1 translate <0,try1,L> rotate  90*z }
      cylinder{<0,0,0>, <0,h1,0>, s1 translate <0,try1,L> rotate 180*z }
      cylinder{<0,0,0>, <0,h1,0>, s1 translate <0,try1,L> rotate 270*z }
      cylinder{<0,0,-s2/2>, <0,0,s2/2>, s2 translate <0,0,L> }
      
      cylinder{<0,0,0>, <0,h2,0>, s2 translate <trx2,try2-h2,L>        }
      cylinder{<0,0,0>, <0,h2,0>, s2 rotate 90*z translate <trx2,try2,L>  }
      
      cylinder{<0,0,0>, <0,h2,0>, s2 translate <trx2,-try2,L>             }
      cylinder{<0,0,0>, <0,h2,0>, s2 rotate 90*z translate <trx2,-try2,L> }
      
      cylinder{<0,0,0>, <0,h2,0>, s2 translate <-trx2,try2-h2,L>          }
      cylinder{<0,0,0>, <0,h2,0>, s2 rotate -90*z translate <-trx2,try2,L> }
                                                             
      cylinder{<0,0,0>, <0,h2,0>, s2 translate <-trx2,-try2,L>             }
      cylinder{<0,0,0>, <0,h2,0>, s2 rotate -90*z translate <-trx2,-try2,L> }
      
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1),(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-3*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-6*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-9*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-12*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-15*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-18*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-21*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-24*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-27*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-30*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-33*s2,(try2-25*s2),L> }
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-36*s2,(try2-25*s2),L> 
      texture { pigment{color 2*<1,0.5,0>}}}
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-39*s2,(try2-25*s2),L> 
      texture { pigment{color 2*<1,0.5,0>}}}
      box{<0,0,0>, <2*s2, 8*s2, s1> translate <(trx2-2*try1)-42*s2,(try2-25*s2),L> 
      texture { pigment{color 2*<1,0.5,0>}}}
      
      text{ ttf "cour.ttf",
         "No ammo", 0.5, 0
         texture { pigment{color 2*<1,0.5,0>}}
         scale 17*s2 translate <try1,try1,L> }
      text{ ttf "cour.ttf",
         "..failed:", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-25*s2),L> }
      text{ ttf "cour.ttf",
         "AA567777:76510001=", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-45*s2),L> }
      text{ ttf "cour.ttf",
         ">trying to connect", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-65*s2),L> }
      text{ ttf "cour.ttf",
         "the right leg:.........", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-85*s2),L> }
      text{ ttf "cour.ttf",
         ".......................", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-105*s2),L> }
      text{ ttf "cour.ttf",
         "...failed:", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-125*s2),L> }
      text{ ttf "cour.ttf",
         "AB567777:76510001=", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-145*s2),L> }
      text{ ttf "cour.ttf",
         "please contact your sup", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-165*s2),L> }
      text{ ttf "cour.ttf",
         "gjhagd", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-185*s2),L> }
      text{ ttf "cour.ttf",
         "Ngfasfhga7oweu", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-205*s2),L> }
      text{ ttf "cour.ttf",
         "81768234628&*kK", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-225*s2),L> }
      text{ ttf "cour.ttf",
         "sg7asdt==", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-245*s2),L> }
      text{ ttf "cour.ttf",
         "9875764,897078508", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-265*s2),L> }
      text{ ttf "cour.ttf",
         "gjhagd!!!!", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-285*s2),L> }
      text{ ttf "cour.ttf",
         "Ngfasfhga7oweu", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-305*s2),L> }
      text{ ttf "cour.ttf",
         "81768234628**&&&K", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-325*s2),L> }
      text{ ttf "cour.ttf",
         "sg7asdt==", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-345*s2),L> }
      text{ ttf "cour.ttf",
         "lhjg8679866", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-365*s2),L> }
      text{ ttf "cour.ttf",
         "Geioip^3 gjhagd!!!!!", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-385*s2),L> }
      text{ ttf "cour.ttf",
         ">fioep$4 NgfasfPOV-Ray3.1", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-405*s2),L> }
      text{ ttf "cour.ttf",
         ">pNcoBa^=C.n.LLIyBa^KNH(12/98)_", 0.05, 0
         scale 17*s2 translate <-(trx2-try1),(try2-425*s2),L> }
   scale <1,1,0.2> translate (4*L/5)*z}   
#end
