#declare treebr = 
/*
cylinder{<0,0,0>, <0,1.2,0>, 0.17 translate -0.1*y
*/
sor{
	15,
	<0.000000,0.000000>,
	<0.002097,0.000022>,
	<0.075489,0.012582>,
	<0.136300,0.046132>,
	<0.174045,0.125815>,
	<0.159366,0.276794>,
	<0.148882,0.404706>,
	<0.138397,0.553588>,
	<0.127912,0.750699>,
	<0.117428,0.866030>,
	<0.100652,0.937325>,
	<0.069198,0.975070>,
	<0.039842,0.993942>,
	<0.004194,1.000233>,
	<0.012582,1.000236>
	sturm
	scale <1,1.2,1> translate -0.1*y
}

#macro tree32( v1 )
   #union{
      #local RR1  = seed(v1);
      #local AN1  = 0;
      #local AN2  = 0;
      #local S1   = <1,1,1>;
      #local tr_vector = <0,0,0>;
      #local Cnt = 0;
      #while(Cnt < 4)
         #local AN1  = AN1 + (10-20*rand(RR1));
         #local AN2  = AN2;
         #local RAN1 = radians(AN1);
         #local RAN2 = radians(AN2);
         #union{
            object{ treebr }
            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate 45*z translate 0.1*y }
            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate -45*z translate 0.1*y }
//            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate 45*z translate 0.3*y }
//            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate -45*z translate 0.3*y }
            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate 45*z translate 0.5*y }
            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate -45*z translate 0.5*y }
//            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate 45*z translate 0.7*y }
//            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate -45*z translate 0.7*y }
            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate 45*z translate 0.9*y }
            cylinder{ <0,0,0>, <0,1,0>, 0.1 rotate -45*z translate 0.9*y }
            scale S1 rotate AN1*z rotate AN2*y translate tr_vector }
         #local S1   = S1*<0.6,1,0.6>;
         #local tr_vector = tr_vector + <-sin(RAN1)*cos(RAN2),cos(RAN1),sin(RAN1)*sin(RAN2)>;
         #local Cnt = Cnt + 1;
      #end
   }
#end

#macro tree42( v1 )
   #union{
      #local RR1  = seed(v1);
      #local AN1  = 0;
      #local AN2  = 0;
      #local RAN1 = radians(AN1);
      #local RAN2 = radians(AN2);
      #local S1   = <0.8,1,0.8>;
      object{ treebr scale S1 rotate AN1*z rotate AN2*y }
      #local tr_vector = <-sin(RAN1)*cos(RAN2),cos(RAN1),sin(RAN1)*sin(RAN2)>;
      #local Cnt = 0;
      #local ScaleFactors = array[6] {0.3,0.4,0.45,0.35,0.2,0.2}
      union{
         #while(Cnt < 4)
            #local AN1  = AN1 +  (11-22*rand(RR1));
            #local AN2  = AN2;
            #local RAN1 = radians(AN1);
            #local RAN2 = radians(AN2);
            #local S1   = S1*<0.6,1,0.6>;
            union{
               object{ treebr scale S1 }
               object{ tree32(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]
                  rotate -70*z }
               object{ tree32(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]
                  rotate -70*z rotate 180*y }
               rotate AN1*z rotate AN2*y translate tr_vector }
            #local tr_vector = tr_vector + <-sin(RAN1)*cos(RAN2),cos(RAN1),sin(RAN1)*sin(RAN2)>;
            #local Cnt = Cnt + 1;
         #end
      rotate 0*y}
   }
#end

#macro tree52( v1 )
   #union{
      #local RR1  = seed(v1);
      #local AN1  = 0;
      #local AN2  = 0;
      #local RAN1 = radians(AN1);
      #local RAN2 = radians(AN2);
      #local S1   = <0.8,1,0.8>;
      object{ treebr scale S1 rotate AN1*z rotate AN2*y }
      #local tr_vector = <-sin(RAN1)*cos(RAN2),cos(RAN1),sin(RAN1)*sin(RAN2)>;
      #local Cnt = 0;
      #local ScaleFactors = array[6] {0.3,0.4,0.45,0.35,0.2,0.2}
      union{
         #while(Cnt < 4)
            #local AN1  = AN1 +  (8-16*rand(RR1));
            #local AN2  = AN2;
            #local RAN1 = radians(AN1);
            #local RAN2 = radians(AN2);
            #local S1   = S1*<0.6,1,0.6>;
            union{
               #if(Cnt = 3)
                  object{ tree42(500*(Cnt+1)*rand(RR1)) scale 0.3*<0.45,1,0.45> }
               #else
                  object{ treebr scale S1 }
               #end
               object{ tree42(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]*<0.45,1,0.45>
                  rotate -45*z }
               object{ tree42(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]*<0.45,1,0.45>
                  rotate -45*z rotate 180*y }
               rotate AN1*z rotate AN2*y translate tr_vector }
            #local tr_vector = tr_vector + <-sin(RAN1)*cos(RAN2),cos(RAN1),sin(RAN1)*sin(RAN2)>;
            #local Cnt = Cnt + 1;
         #end
      rotate 90*y}
   }
#end

#macro tree62( v1 )
   #union{
      #local RR1  = seed(v1);
      #local AN1  = 3*rand(RR1);
      #local AN2  = 360*rand(RR1);
      #local RAN1 = radians(AN1);
      #local RAN2 = radians(AN2);
      #local S1   = <1,1,1>;
      #local SS1  = 1;
      object{ treebr scale <1,3,1> rotate AN1*z rotate AN2*y } 
      #local tr_vector = 3*<-sin(RAN1)*cos(RAN2),cos(RAN1),sin(RAN1)*sin(RAN2)>;
      #local Cnt = 0;
      #local ScaleFactors = array[6] {0.3,0.2,0.3,0.3,0.2,0.1}
      #while(Cnt < 5)
         #local AN1  = AN1 + 6*rand(RR1);
         #if(Cnt = 1)
            #local AN2  = AN2 + 360*rand(RR1)+ 30;
         #else
            #local AN2  = AN2 + 360*rand(RR1);
         #end
         #local RAN1 = radians(AN1);
         #local RAN2 = radians(AN2);
         #local S1   = S1*<0.59,0.9,0.59>;
         #local SS1  = SS1*0.9;
         union{
            object{ treebr scale S1 }
            object{ tree52(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]
               rotate -90*z rotate (30-60*rand(RR1))*y }
            object{ tree52(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]
               rotate -90*z rotate (90+(30-60*rand(RR1)))*y }
            object{ tree52(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]
               rotate -90*z rotate (180+(30-60*rand(RR1)))*y }
            object{ tree52(500*(Cnt+1)*rand(RR1)) scale ScaleFactors[Cnt+1]
               rotate -90*z rotate (270+(30-60*rand(RR1)))*y }
            rotate AN1*z rotate AN2*y translate tr_vector }
         #local tr_vector = tr_vector + SS1*<-sin(RAN1)*cos(RAN2),cos(RAN1),sin(RAN1)*sin(RAN2)>;
         #local Cnt = Cnt + 1;
      #end
   }
#end

